<template>
  <div>
    <v-card class="mt-5 mb-5">
      <v-card-title>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
        ></v-text-field>
        <v-spacer></v-spacer>
        <v-btn
          class="ma-2 success"
          dark
          @click="handleCreateData"
          tile
          outlined
        >
          <v-icon>mdi-plus</v-icon>เพิ่ม
        </v-btn>
      </v-card-title>
      <v-data-table
        :headers="headers"
        :items="itemData"
        :search="search"
        :items-per-page="10"
        :sort-by="['name', 'detail']"
        :sort-desc="[false, true]"
        item-key="id"
        multi-sort
        class="elevation-1"
      >
        <!-- <template #item.name="{ item }">  สำหรับ Object ใน Array [{}]
                      <span class="body-2">{{item.name.toUpperCase()}}</span>
                  </template> -->
        <!-- <template #item.typeExpenses="{ item }"> 
          <span v-for="typeex in item.typeExpenses" :key="typeex.id"
            >{{ typeex.id }} {{ item.typeExpenses.name }}</span
          >
        </template> -->
        <template #item.typeExpenses="{ item }">
          <span>{{ item.typeExpenses.name }}</span>
        </template>
        <template #item.action="{ item }">
          <v-btn
            class="mr-1 mb-2"
            color="orange darken-2"
            small
            dark
            @click="handleEditdata(item)"
          >
            <v-icon small dark> mdi-pencil </v-icon>
          </v-btn>
          <v-btn
            class="mr-1 mb-2"
            color="red darken-2"
            small
            dark
            @click="handleDeldata(item)"
          >
            <v-icon small> mdi-delete </v-icon>
          </v-btn>
        </template>
      </v-data-table>
    </v-card>
  </div>
</template>
<script>
import Swal from 'sweetalert2'

export default {
  props: ['itemData'],
  data: () => ({
    search: '',
    headers: [
      {
        text: 'ชื่อ',
        align: 'start',
        value: 'name',
        class: 'subtitle-2 font-weight-bold',
      },
      {
        text: 'รายละเอียด',
        value: 'detail',
        class: 'subtitle-2 font-weight-bold',
      },
      {
        text: 'ประเภทค่าใช้จ่าย',
        value: 'typeExpenses',
        class: 'subtitle-2 font-weight-bold',
        sortable: false,
      },
      {
        text: 'เครื่องมือ',
        align: 'center',
        width: '19%',
        value: 'action',
        sortable: false,
        class: 'subtitle-2 font-weight-bold',
      },
    ],
  }),
  methods: {
    handleCreateData() {
      //เพิ่ม 1 (ListForm) แสดงฟอร์มสำหรับเพิ่มข้อมูล

      //เพิ่ม 1.1 (ListForm) Set Commit จัดการ EditItem ล่าสุด  เข้า State สำหรับ กดหนด Add/Edit
      this.$store.commit('SET_Expenses_List_EditItem', -1)

      //เพิ่ม 1.2 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit(
        'SET_FORM_EXPENSES_LIST',
        !this.$nuxt.$store.state.expenseslist.formExpensesList
      )
    },
    handleEditdata(val) {
      //แก้ไข 1 (ListForm) แสดงฟอร์มสำหรับแก้ไขข้อมูล

      this.valList = val
      this.editIndex = 1
      //แก้ไข 1.1 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_List_EditItem', 1)
      // console.log("Edit :", val)
      //เพิ่ม 1.2 (ListForm) Set Commit จัดการ formExpensesList ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_FORM_EXPENSES_LIST', true)
      //เพิ่ม 1.3 (ListForm) Set Commit จัดการ val เข้า  ล่าสุด  เข้า State สำหรับ Form Show/hide
      this.$store.commit('SET_Expenses_List_EditData', val)
    },
    handleDeldata(val) {
      //ลบ 1 (ListForm) แสดงฟอร์มสำหรับแก้ไขข้อมูล
      Swal.fire({
        title: 'คุณแน่ใจหรือไม่',
        text: 'คุณต้องการลบข้อมูลนี้',
        icon: 'warning',
        showCancelButton: true,
        cancelButtonColor: '#0288D1',
        confirmButtonColor: '#D32F2F',
        cancelButtonText: 'ยกเลิก',
        confirmButtonText: 'ใช่, ลบข้อมูล',
      }).then((result) => {
        if (result.isConfirmed) {
          //ลบ 1 (ListForm) dispatch พร้อม parameter "val" ไปยัง Fnc ลบข้อมูล
          this.$store.dispatch('delDataExpensesList', val).then(() => {
            Swal.fire('ลบข้อมูล', 'คุณได้ลบข้อมูลเรียบร้อยแล้ว', 'success')
          })
        }
      })
    },
  },
}
</script>